#include <bits/stdc++.h>
#define int long long
using namespace std;
int n,k,a[1048576],dp[2048][2048];
signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin>>n>>k;
    for(int i=1; i<=n; i++)cin>>a[i];
    dp[1][1]=a[1];
    for(int i=2;i<=n;i++)
    {
        for(int j=1;j<=i;j++)dp[i][1]|=a[j];
        for(int j=2;j<=n;j++)
        {
            int x=a[i];
            for(int t=i-1;t>0;t--)
            {
                dp[i][j]=max(dp[i][j],(dp[t][j-1]&x));
                x|=a[t];
            }
        }
    }
    cout<<dp[n][k]<<endl;
    return 0;
}
